pkgname="nvidia-l4t"
pkgbase="nvidia-l4t"
pkgver="32.3.1"
pkgrel="1.3"
pkgdesc="Tegra BSP drivers"
arch=("any")
url="https://www.nvidia.com/"
license=("GPL")
makedepends=("binutils")
install=tegra-bsp.install
source=(
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-3d-core/nvidia-l4t-3d-core_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-bootloader/nvidia-l4t-bootloader_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-camera/nvidia-l4t-camera_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-ccp-t210ref/nvidia-l4t-ccp-t210ref_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-configs/nvidia-l4t-configs_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-core/nvidia-l4t-core_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-cuda/nvidia-l4t-cuda_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-firmware/nvidia-l4t-firmware_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-graphics-demos/nvidia-l4t-graphics-demos_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-gstreamer/nvidia-l4t-gstreamer_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-init/nvidia-l4t-init_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-initrd/nvidia-l4t-initrd_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-jetson-io/nvidia-l4t-jetson-io_32.3.1-20200115120740_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-jetson-multimedia-api/nvidia-l4t-jetson-multimedia-api_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-kernel/nvidia-l4t-kernel_4.9.140-tegra-32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-kernel-dtbs/nvidia-l4t-kernel-dtbs_4.9.140-tegra-32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-kernel-headers/nvidia-l4t-kernel-headers_4.9.140-tegra-32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-multimedia/nvidia-l4t-multimedia_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-multimedia-utils/nvidia-l4t-multimedia-utils_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-oem-config/nvidia-l4t-oem-config_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-tools/nvidia-l4t-tools_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-wayland/nvidia-l4t-wayland_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-weston/nvidia-l4t-weston_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-x11/nvidia-l4t-x11_32.3.1-20191209225816_arm64.deb"
	"https://repo.download.nvidia.com/jetson/t210/pool/main/n/nvidia-l4t-xusb-firmware/nvidia-l4t-xusb-firmware_32.3.1-20191209225816_arm64.deb"
	"nvidia-tegra.conf"
	"switch-l4t-configs.tar.gz::https://gitlab.com/l4t-community/gnu-linux/switch-l4t-configs/-/archive/master/switch-l4t-configs-master.tar.gz"
)

sha512sums=(
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
	"SKIP"
)

prepare() {
	tar xf $srcdir/switch-l4t-configs*.tar.gz
	mv switch-l4t-configs-* $srcdir/switch-l4t-configs
}

package-3d-core() {
	pkgdesc="Nvidia L4T 3D Core"
	provides=("nvidia-l4t-3d-core")

	ar x $srcdir/nvidia-l4t-3d-core*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-ccp-t210ref() {
	pkgdesc="Nvidia L4T CCP t210ref"
	provides=("nvidia-l4t-ccp-t210ref")

	ar x $srcdir/nvidia-l4t-ccp-t210ref*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-camera() {
	pkgdesc="Nvidia L4T Camera"
	provides=("nvidia-l4t-camera")

	ar x $srcdir/nvidia-l4t-camera*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary

	mkdir -p $pkgdir/usr/bin
	mv $pkgdir/usr/sbin/* $pkgdir/usr/bin/
	rm -rf $pkgdir/usr/sbin
}

package-configs() {
	pkgdesc="Nvidia L4T Configs"
	provides=("nvidia-l4t-configs")
	
	ar x $srcdir/nvidia-l4t-configs*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary

	# Switchroot nvpmodel assets
	cp -r $srcdir/switch-l4t-configs/switch-nvpmodel/* $srcdir
	cp $srcdir/NVIDIA_Login_Logo.png $srcdir/NVIDIA_Logo.png $srcdir/NVIDIA_Wallpaper.jpg \
		$pkgdir/usr/share/backgrounds/

	rm -rf $pkgdir/etc/systemd/system/apt-daily.timer.d/ \
		$pkgdir/etc/systemd/system/apt-daily-upgrade.timer.d/
}

package-core() {
	pkgdesc="Nvidia L4T Core"
	provides=("nvidia-l4t-core")

	ar x $srcdir/nvidia-l4t-core*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary

	cp $srcdir/nvidia-tegra.conf $pkgdir/etc/ld.so.conf.d/nvidia-tegra.conf

	mkdir -p $pkgdir/usr/bin
	mv $pkgdir/usr/sbin/* $pkgdir/usr/bin/
	rm -rf $pkgdir/usr/sbin
}

package-cuda() {
	pkgdesc="Nvidia L4T Cuda"
	provides=("nvidia-l4t-cuda")

	ar x $srcdir/nvidia-l4t-cuda*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-firmware() {
	pkgdesc="Nvidia L4T Firmware files"
	provides=("nvidia-l4t-firmware")

	ar x $srcdir/nvidia-l4t-firmware*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary

	mkdir -p $pkgdir/usr/bin $pkgdir/usr/lib/
	mv $pkgdir/usr/sbin/* $pkgdir/usr/bin/
	mv $pkgdir/lib/* $pkgdir/usr/lib/
	rm -rf $pkgdir/usr/sbin $pkgdir/lib

	ln -sf "../tegra21x/acr_ucode.bin" "$pkgdir/usr/lib/firmware/gm20b/acr_ucode.bin"
	ln -sf "../tegra21x/gpmu_ucode.bin" "$pkgdir/usr/lib/firmware/gm20b/gpmu_ucode.bin"
	ln -sf "../tegra21x/gpmu_ucode_desc.bin" "$pkgdir/usr/lib/firmware/gm20b/gpmu_ucode_desc.bin"
	ln -sf "../tegra21x/gpmu_ucode_image.bin" "$pkgdir/usr/lib/firmware/gm20b/gpmu_ucode_image.bin"
	ln -sf "../tegra21x/gpu2cde.bin" "$pkgdir/usr/lib/firmware/gm20b/gpu2cde.bin"
	ln -sf "../tegra21x/NETB_img.bin" "$pkgdir/usr/lib/firmware/gm20b/NETB_img.bin"
	ln -sf "../tegra21x/fecs_sig.bin" "$pkgdir/usr/lib/firmware/gm20b/fecs_sig.bin"
	ln -sf "../tegra21x/pmu_sig.bin" "$pkgdir/usr/lib/firmware/gm20b/pmu_sig.bin"
	ln -sf "../tegra21x/pmu_bl.bin" "$pkgdir/usr/lib/firmware/gm20b/pmu_bl.bin"
	ln -sf "../tegra21x/fecs.bin" "$pkgdir/usr/lib/firmware/gm20b/fecs.bin"
	ln -sf "../tegra21x/gpccs.bin" "$pkgdir/usr/lib/firmware/gm20b/gpccs.bin"

	rm $pkgdir/usr/lib/systemd/system/bluetooth.service.d/nv-bluetooth-service.conf
}

package-graphics-demos() {
	pkgdesc="Nvidia L4T graphics demos"
	provides=("nvidia-l4t-graphics-demos")
	ar x $srcdir/nvidia-l4t-graphics-demos*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-gstreamer() {
	pkgdesc="Nvidia L4T Gstreamer"
	provides=("nvidia-l4t-gstreamer")

	ar x $srcdir/nvidia-l4t-gstreamer*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	
	for link in `find $pkgdir/usr/lib/aarch64-linux-gnu/ -maxdepth 1 -type f -printf '%f\n'`; do
		ln -sfn /usr/lib/aarch64-linux-gnu/$link $pkgdir/usr/lib/$link
	done

	cp -r $pkgdir/usr/lib/aarch64-linux-gnu/gstreamer-1.0/ $pkgdir/usr/lib/
   	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-init() {
	pkgdesc="Nvidia L4T init"
	provides=("nvidia-l4t-init")

	ar x $srcdir/nvidia-l4t-init_*_arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary $pkgdir/etc/systemd/sleep.conf

	sed -i 's+cp -r /proc/device-tree/chosen/plugin-manager \"${mntpoint}/version/plugin-manager\"+\#cp -r /proc/device-tree/chosen/plugin-manager \"${mntpoint}/version/plugin-manager\"+g' $pkgdir/opt/nvidia/l4t-usb-device-mode/nv-l4t-usb-device-mode-start.sh

	mkdir -p $pkgdir/usr/bin
	mv $pkgdir/usr/sbin/* $pkgdir/usr/bin/
	rm -rf $pkgdir/usr/sbin
}

package-initrd() {
	pkgdesc="Nvidia L4T initrd"
	provides=("nvidia-l4t-initrd")

	ar x $srcdir/nvidia-l4t-initrd_*_arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-kernel() {
	pkgdesc="Nvidia L4T kernel"
    	provides=("nvidia-l4t-kernel")

    	ar x $srcdir/nvidia-l4t-kernel_*_arm64.deb --output $pkgdir
    	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
    	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-kernel-dtbs() {
	pkgdesc="Nvidia L4T kernel dtbs"
    	provides=("nvidia-l4t-kernel-dtbs")

    	ar x $srcdir/nvidia-l4t-kernel-dtbs_*_arm64.deb --output $pkgdir
    	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
    	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-kernel-headers() {
	pkgdesc="Nvidia L4T kernel dtbs"
    	provides=("nvidia-l4t-kernel-headers")

    	ar x $srcdir/nvidia-l4t-kernel-headers_*_arm64.deb --output $pkgdir
    	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
    	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-jetson-io() {
	pkgdesc="Nvidia L4T Jetson-IO"
	provides=("nvidia-l4t-jetson-io")

	ar x $srcdir/nvidia-l4t-jetson-io*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
   	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-jetson-multimedia-api() {
	pkgdesc="Nvidia L4T Multimedia"
	provides=("nvidia-l4t-jetson-multimedia-api")

	ar x $srcdir/nvidia-l4t-jetson-multimedia-api*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-multimedia() {
	pkgdesc="Nvidia L4T Multimedia"
	provides=("nvidia-l4t-multimedia")

	ar x $srcdir/nvidia-l4t-multimedia_*_arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-multimedia-utils() {
	pkgdesc="Nvidia L4T Multimedia Utils"
	provides=("nvidia-l4t-multimedia-utils")

	ar x $srcdir/nvidia-l4t-multimedia-utils*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-oem-config() {
	pkgdesc="Nvidia L4T OEM config"
	provides=("nvidia-l4t-oem-config")

	ar x $srcdir/nvidia-l4t-oem-config*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary 

	mkdir -p $pkgdir/usr/bin $pkgdir/usr/lib/
	mv $pkgdir/usr/sbin/* $pkgdir/usr/bin/
	mv $pkgdir/lib/* $pkgdir/usr/lib/
	rm -rf $pkgdir/usr/sbin $pkgdir/lib
}

package-tools() {
	pkgdesc="Nvidia L4T Tools"
	provides=("nvidia-l4t-tools")

	ar x $srcdir/nvidia-l4t-tools*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary

	# Switchroot nvpmodel scripts
	cp -r $srcdir/switch-l4t-configs/switch-nvpmodel/* $srcdir
  
	cp $srcdir/nv_logo.svg $srcdir/nvpmodel_helper.sh $srcdir/nvpmodel_indicator.py \
	  $srcdir/nvpmodel.py $pkgdir/usr/share/nvpmodel_indicator/
 
	cp $srcdir/nvpmodel_t210.conf $srcdir/nvpmodel_charging.conf $pkgdir/etc/nvpmodel/

	# Nvmpodel fixes
	sed -i s/x-terminal-emulator/konsole/g $pkgdir/usr/share/nvpmodel_indicator/nvpmodel_indicator.py
        sed -i 's/OnlyShowIn.*//g' $pkgdir/etc/xdg/autostart/nvpmodel_indicator.desktop
        chmod +x $pkgdir/usr/share/nvpmodel_indicator/nvpmodel_helper.sh

	mkdir -p $pkgdir/usr/bin
	mv $pkgdir/usr/sbin/* $pkgdir/usr/bin/
	rm -rf $pkgdir/usr/sbin
}

package-wayland() {
	pkgdesc="Nvidia L4T Wayland"
	provides=("nvidia-l4t-wayland")

	ar x $srcdir/nvidia-l4t-wayland*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-weston() {
	pkgdesc="Nvidia L4T Weston"
	provides=("nvidia-l4t-weston")

	ar x $srcdir/nvidia-l4t-weston*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-x11() {
	pkgdesc="Nvidia L4T X.Org configuration files"
	provides=("nvidia-l4t-x11")

	ar x $srcdir/nvidia-l4t-x11*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary
}

package-xusb-firmware() {
	pkgdesc="Nvidia L4T XUSB firmware"
	provides=("nvidia-l4t-xusb-firmware")

	ar x $srcdir/nvidia-l4t-xusb-firmware*arm64.deb --output $pkgdir
	tar  -xvf $pkgdir/data.tar.* -C $pkgdir
	rm $pkgdir/data.tar.* $pkgdir/control.tar.* $pkgdir/debian-binary

	mkdir -p $pkgdir/usr/lib/
	mv $pkgdir/lib/* $pkgdir/usr/lib/
	rm -rf $pkgdir/lib
}

pkgname=(
	"${pkgbase}-3d-core"
	"${pkgbase}-camera"
	"${pkgbase}-ccp-t210ref"
	"${pkgbase}-configs"
	"${pkgbase}-core"
	"${pkgbase}-cuda"
	"${pkgbase}-firmware"
	"${pkgbase}-graphics-demos"
	"${pkgbase}-gstreamer"
	"${pkgbase}-init"
	"${pkgbase}-initrd"
	"${pkgbase}-jetson-io"
	"${pkgbase}-jetson-multimedia-api"
	"${pkgbase}-kernel"
	"${pkgbase}-kernel-dtbs"
	"${pkgbase}-kernel-headers"
	"${pkgbase}-multimedia"
	"${pkgbase}-multimedia-utils"
	"${pkgbase}-oem-config"
	"${pkgbase}-tools"
	"${pkgbase}-wayland"
	"${pkgbase}-weston"
	"${pkgbase}-x11"
	"${pkgbase}-xusb-firmware"
)
for _p in "${pkgname[@]}"; do
  eval "package_$_p() {
    $(declare -f "package${_p#$pkgbase}")
    package${_p#$pkgbase}
  }"
done
